/********************************** (C) COPYRIGHT *******************************
* File Name          : main.c
* Author             : WCH
* Version            : V1.0.0
* Date               : 2021/06/06
* Description        : Main program body.
*********************************************************************************
* Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.
* Attention: This software (modified or not) and binary are used for 
* microcontroller manufactured by Nanjing Qinheng Microelectronics.
*******************************************************************************/

/*
 *@Note
 USART Print debugging routine:
 USART1_Tx(PA9).
 This example demonstrates using USART1(PA9) as a print debug port output.

*/

#include "debug.h"
#include <stdio.h>
#include <stdint.h>
#include <string.h>
#include "math.h"

char buf[] = "0000018CD2063DA0";


uint64_t power(int base, int exponent)
{
    uint64_t result = 1;
    for (int i = 0; i < exponent; i++)
    {
        result *= base;
    }
    return result;
}

uint64_t Bc260_Hex2Hec(char *hex_arry)
{
    int value = 0;
    uint64_t dec_value = 0;

    for(int i = strlen(hex_arry)-1; i >= 0; i--)
    {
        if(hex_arry[i] >= '0' && hex_arry[i] <= '9')
        {
            value = hex_arry[i] - '0';
        }
        else if(hex_arry[i] >= 'a' && hex_arry[i] <= 'f')
        {
            value = (hex_arry[i] - 'a' + 10);
        }
        else if(hex_arry[i] >= 'A' && hex_arry[i] <= 'F')
        {
            value = (hex_arry[i] - 'A' + 10);
        }
        else
        {
            // Handle error if the character is not a valid hex digit.
            printf("Invalid hex digit: %c\n", hex_arry[i]);
            continue;
        }

        u8 cnt=sizeof(buf)-2;
        dec_value += value * power(16, cnt - i);
        printf("dec_value[%d] = %lld\r\n", i, dec_value);
    }

    return dec_value;

}



/*********************************************************************
 * @fn      main
 *
 * @brief   Main program.
 *
 * @return  none
 */
int main(void)
{
    uint64_t dec = 0;

	NVIC_PriorityGroupConfig(NVIC_PriorityGroup_2);
	SystemCoreClockUpdate();
	Delay_Init();
	USART_Printf_Init(115200);	

	printf("SystemClk:%d\r\n",SystemCoreClock);
	printf( "ChipID:%08x\r\n", DBGMCU_GetCHIPID() );
	printf("This is printf example\r\n");

    dec = Bc260_Hex2Hec(buf);

    printf("sum = %lld\r\n", dec);

	while(1)
    {

	}
}

